# B站直播监视系统

#### 介绍
这是一个监控B站直播间的后台系统。

1. 可以监控直播间礼物、金额、人气（B站已废弃接口） 、弹幕
2. 录制直播间（高清或收费直播间需要登录），需要FFmpeg
3. 录制直播间弹幕到数据库（sqlite），可转换成ass字幕


#### 软件架构
后端：
1. SpringBoot
2. SQLite
3. FFmpeg

网页前端：
1. layui


#### 安装教程

1. git clone 本项目
2. 进入项目：`cd biliob`
3. 编译：`mvnw package`
4. 运行：`java -jar target/bilibili-0.0.1-SNAPSHOT.jar`

#### 使用说明

运行项目后访问`http://127.0.0.1:8001/` 即可

*关于mysql部分未来上传sql文件

