package com.yutou.bilibili.mybatis.model;

import java.util.ArrayList;
import java.util.List;

public class SConfigExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public SConfigExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andConfigkeyIsNull() {
            addCriterion("configKey is null");
            return (Criteria) this;
        }

        public Criteria andConfigkeyIsNotNull() {
            addCriterion("configKey is not null");
            return (Criteria) this;
        }

        public Criteria andConfigkeyEqualTo(String value) {
            addCriterion("configKey =", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyNotEqualTo(String value) {
            addCriterion("configKey <>", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyGreaterThan(String value) {
            addCriterion("configKey >", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyGreaterThanOrEqualTo(String value) {
            addCriterion("configKey >=", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyLessThan(String value) {
            addCriterion("configKey <", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyLessThanOrEqualTo(String value) {
            addCriterion("configKey <=", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyLike(String value) {
            addCriterion("configKey like", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyNotLike(String value) {
            addCriterion("configKey not like", value, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyIn(List<String> values) {
            addCriterion("configKey in", values, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyNotIn(List<String> values) {
            addCriterion("configKey not in", values, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyBetween(String value1, String value2) {
            addCriterion("configKey between", value1, value2, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigkeyNotBetween(String value1, String value2) {
            addCriterion("configKey not between", value1, value2, "configkey");
            return (Criteria) this;
        }

        public Criteria andConfigvalueIsNull() {
            addCriterion("configValue is null");
            return (Criteria) this;
        }

        public Criteria andConfigvalueIsNotNull() {
            addCriterion("configValue is not null");
            return (Criteria) this;
        }

        public Criteria andConfigvalueEqualTo(String value) {
            addCriterion("configValue =", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueNotEqualTo(String value) {
            addCriterion("configValue <>", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueGreaterThan(String value) {
            addCriterion("configValue >", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueGreaterThanOrEqualTo(String value) {
            addCriterion("configValue >=", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueLessThan(String value) {
            addCriterion("configValue <", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueLessThanOrEqualTo(String value) {
            addCriterion("configValue <=", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueLike(String value) {
            addCriterion("configValue like", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueNotLike(String value) {
            addCriterion("configValue not like", value, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueIn(List<String> values) {
            addCriterion("configValue in", values, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueNotIn(List<String> values) {
            addCriterion("configValue not in", values, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueBetween(String value1, String value2) {
            addCriterion("configValue between", value1, value2, "configvalue");
            return (Criteria) this;
        }

        public Criteria andConfigvalueNotBetween(String value1, String value2) {
            addCriterion("configValue not between", value1, value2, "configvalue");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}