package com.yutou.bilibili;

import com.yutou.bilibili.BiliBili.Live;
import com.yutou.bilibili.BiliBili.Tools.LiveT;
import com.yutou.bilibili.QQBot.QQBotManager;
import com.yutou.bilibili.Tools.ExcelUtils;
import com.yutou.bilibili.Tools.ServiceTools;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Import;

@Import({Live.class,ServiceTools.class, ExcelUtils.class, QQBotManager.class})
@SpringBootApplication
public class BilibiliApplication {

    public static String version="0.8.4";

    public static void main(String[] args) {
        QQBotManager.getInstance().init();
        SpringApplication.run(BilibiliApplication.class, args);
    }

}
